Index: issm/trunk/src/c/modules/SurfaceMassBalancex/Gembx.cpp
===================================================================
--- issm/trunk/src/c/modules/SurfaceMassBalancex/Gembx.cpp	(revision 27035)
+++ issm/trunk/src/c/modules/SurfaceMassBalancex/Gembx.cpp	(revision 27232)
@@ -23,8 +23,8 @@
 
 const double CI = 2102.0;                       // heat capacity of snow/ice (J kg-1 k-1)
-const double LF = 0.3345E6;             // latent heat of fusion (J kg-1)
-const double LV = 2.495E6;               // latent heat of vaporization (J kg-1)
-const double LS = 2.8295E6;             // latent heat of sublimation (J kg-1)
-const double SB = 5.67E-8;                // Stefan-Boltzmann constant (W m-2 K-4)
+const double LF = 0.3345e6;             // latent heat of fusion (J kg-1)
+const double LV = 2.495e6;               // latent heat of vaporization (J kg-1)
+const double LS = 2.8295e6;             // latent heat of sublimation (J kg-1)
+const double SB = 5.67e-8;                // Stefan-Boltzmann constant (W m-2 K-4)
 const double CA = 1005.0;                    // heat capacity of air (J kg-1 K-1)
 const double R = 8.314;                      // gas constant (J mol-1 K-1)
@@ -159,4 +159,6 @@
 	// convert T from K to degC
 	T = T - CtoK;
+	// convert dT from degC/m to degC/cm
+	dT = dT/100;
 
 	// temperature coefficient F
@@ -279,5 +281,5 @@
 
 	 INPUTS
-	 * T: grid cell temperature [k]
+	 * T: grid cell temperature [K]
 	 * dz: grid cell depth [m]
 	 * d: grid cell density [kg m-3]
@@ -295,4 +297,5 @@
 	/*intermediary: */
 	IssmDouble  dt=0.0;
+	IssmDouble  Ti=0.0;
 	IssmDouble* gsz=NULL;
 	IssmDouble* dT=NULL;
@@ -332,5 +335,5 @@
 
 	/* Calculate temperature gradiant across grid cells 
-	 * Returns the avereage gradient across the upper and lower grid cell */
+	 * Returns the average gradient across the upper and lower grid cell */
 
 	//initialize
@@ -345,5 +348,9 @@
 
 	// Take forward differences on left and right edges
-	if(m>1){
+	if(m>2){
+		dT[0] = (T[2] - T[0])/(zGPC[2]-zGPC[0]);
+		dT[m-1] = (T[m-1] - T[m-3])/(zGPC[m-1]-zGPC[m-3]);
+	}
+	else if(m>1){
 		dT[0] = (T[1] - T[0])/(zGPC[1]-zGPC[0]);
 		dT[m-1] = (T[m-1] - T[m-2])/(zGPC[m-1]-zGPC[m-2]);
@@ -358,4 +365,8 @@
 	/*Snow metamorphism. Depends on value of snow dendricity and wetness of the snowpack: */
 	for(int i=0;i<m;i++){
+
+		// T for this layer
+		Ti = T[i];
+
 		if (gdn[i]>0.0+Gdntol){
 
@@ -363,8 +374,8 @@
 				//_printf_("Dendritic dry snow metamorphism\n");
 				//index for dentricity > 0 and T gradients < 5 degC m-1 and >= 5 degC m-1
-				if(dT[i]<=5.0+Ttol){
+				if(fabs(dT[i])<=5.0+Ttol){
 					//determine coefficients
-					IssmDouble A = - 2e8 * exp(-6e3 / T[i]) * dt;
-					IssmDouble B = 1e9 * exp(-6e3 / T[i]) * dt;
+					IssmDouble A = - 2e8 * exp(-6e3 / Ti) * dt;
+					IssmDouble B = 1e9 * exp(-6e3 / Ti) * dt;
 					//new dentricity and sphericity for dT < 5 degC m-1
 					gdn[i] += A;
@@ -374,6 +385,6 @@
 					// new dendricity and sphericity for dT >= 5 degC m-1
 
-					//determine coeff0icients
-					IssmDouble C = (-2e8 * exp(-6e3 / T[i]) * dt) * pow(dT[i],.4);
+					//determine coefficients
+					IssmDouble C = (-2e8 * exp(-6e3 / Ti) * dt) * pow(fabs(dT[i]),.4);
 					gdn[i] +=C;
 					gsp[i] +=C;
@@ -399,5 +410,5 @@
 
          // determine new grain size (mm)
-         gsz[i] = 0.1 + (1.0-gdn[i])*0.25 + (0.5-gsp[i])*0.1;
+			gsz[i] = 1e-1*(gdn[i]/.99+(1-1*gdn[i]/.99)*(gsp[i]/.99*3+(1-gsp[i]/.99)*4));
 
 		}
@@ -413,6 +424,6 @@
 				IssmDouble F = 0.0;
 
-				if (dT[i]>5.0+Ttol){
-					F = (-2e8 * exp(-6e3 / T[i]) * dt) * pow(dT[i],.4);
+				if (fabs(dT[i])>5.0+Ttol){
+					F = (-2e8 * exp(-6e3 / Ti) * dt) * pow(fabs(dT[i]),.4);
 				}
 				else if (W[i]>0.0+Wtol){
@@ -420,5 +431,5 @@
 				}
 				else{
-					F = 1e9 * exp(-6e3 / T[i]) * dt;
+					F = 1e9 * exp(-6e3 / Ti) * dt;
 				}
 				gsp[i] +=F;
@@ -430,7 +441,7 @@
 			/*Dry snow metamorphism (Marbouty, 1980) grouped model coefficents
 			 *from Marbouty, 1980: Figure 9*/
-			if(W[i]<=0.0+Wtol || (gsp[i]<=0.0+Gdntol && dT[i]>5.0+Ttol)){
+			if(W[i]<=0.0+Wtol || (gsp[i]<=0.0+Gdntol && fabs(dT[i])>5.0+Ttol)){
 				//_printf_("Nondendritic snow metamorphism\n");
-				Q = Marbouty(T[i],d[i],dT[i]);
+				Q = Marbouty(Ti,d[i],dT[i]);
 
 				// calculate grain growth
@@ -568,5 +579,5 @@
 			// spectral range:
 			// 0.3 - 0.8um
-			IssmDouble a0 = min(0.98, 1 - 1.58 *pow(gsz,0.5));
+			IssmDouble a0 = min(0.98, 0.95 - 1.58 *pow(gsz,0.5));
 			// 0.8 - 1.5um
 			IssmDouble a1 = max(0., 0.95 - 15.4 *pow(gsz,0.5));
@@ -694,5 +705,5 @@
 
 }  /*}}}*/
-void thermo(IssmDouble* pEC, IssmDouble** pT, IssmDouble* pulwrf, IssmDouble* re, IssmDouble* dz, IssmDouble* d, IssmDouble* swf, IssmDouble dlwrf, IssmDouble Ta, IssmDouble V, IssmDouble eAir, IssmDouble pAir, IssmDouble eIdx, IssmDouble teValue, IssmDouble dulwrfValue, IssmDouble teThresh, IssmDouble Ws, IssmDouble dt0, int m, IssmDouble Vz, IssmDouble Tz, IssmDouble thermo_scaling, IssmDouble dIce, int sid, bool isconstrainsurfaceT, bool isdeltaLWup) { /*{{{*/
+void thermo(IssmDouble* pshf, IssmDouble* plhf, IssmDouble* pEC, IssmDouble** pT, IssmDouble* pulwrf, IssmDouble* re, IssmDouble* dz, IssmDouble* d, IssmDouble* swf, IssmDouble dlwrf, IssmDouble Ta, IssmDouble V, IssmDouble eAir, IssmDouble pAir, IssmDouble tcIdx, IssmDouble eIdx, IssmDouble teValue, IssmDouble dulwrfValue, IssmDouble teThresh, IssmDouble Ws, IssmDouble dt0, IssmDouble dzMin, int m, IssmDouble Vz, IssmDouble Tz, IssmDouble thermo_scaling, IssmDouble dIce, int sid, bool isconstrainsurfaceT, bool isdeltaLWup) { /*{{{*/
 
 	/* ENGLACIAL THERMODYNAMICS*/
@@ -742,13 +753,21 @@
 	IssmDouble* Td = NULL;
 
-	IssmDouble  z0=0.0;	
-	IssmDouble  dt=0.0;
+	IssmDouble z0=0.0;	
+	IssmDouble zT=0.0;
+	IssmDouble zQ=0.0;
+	IssmDouble zratio=1;
+	IssmDouble dt=0.0;
 	IssmDouble max_fdt=0.0;
-	IssmDouble  Ts=0.0;
-	IssmDouble  L=0.0;
-	IssmDouble  eS=0.0;
-	IssmDouble  Ri=0.0;
-	IssmDouble  coefM=0.0;
-	IssmDouble  coefH=0.0;
+	IssmDouble Ts=0.0;
+	IssmDouble L=0.0;
+	IssmDouble eS=0.0;
+	IssmDouble Ri=0.0;
+	IssmDouble coefM=0.0;
+	IssmDouble coefH=0.0;
+	IssmDouble coefHT=0.0;
+	IssmDouble coefHQ=0.0;
+	IssmDouble An_num=0.0;
+	IssmDouble An_den_T=0.0;
+	IssmDouble An_den_Q=0.0;
 	IssmDouble An=0.0;
 	IssmDouble C=0.0;
@@ -759,4 +778,6 @@
 	IssmDouble lhf=0.0;
 	IssmDouble EC_day=0.0;
+	IssmDouble lhf_cum=0.0;
+	IssmDouble shf_cum=0.0;
 	IssmDouble dT_turb=0.0;
 	IssmDouble turb=0.0;
@@ -789,15 +810,21 @@
 	// SURFACE ROUGHNESS (Bougamont, 2006)
 	// wind/temperature surface roughness height [m]
-	if (ds < dIce-Dtol && fabs(Ws) < Wtol) z0 = 0.00012;       // 0.12 mm for dry snow
+	if (ds < dIce-Dtol && Ws < Wtol) z0 = 0.00012;        // 0.12 mm for dry snow
 	else if (ds >= dIce-Dtol) z0 = 0.0032;             // 3.2 mm for ice
 	else z0 = 0.0013;                            // 1.3 mm for wet snow
 
+	//zT and zQ are percentage of z0 (Foken 2008)
+	zratio=10;
+	zT=z0/zratio;
+	zQ=z0/zratio;
+
 	// if V = 0 goes to infinity therfore if V = 0 change
 	if(V<0.01-Dtol)V=0.01;
 
 	// Bulk-transfer coefficient for turbulent fluxes
-	//An =  pow(0.4,2) / pow(log(Tz/z0),2);     // Bulk-transfer coefficient
-	An =  pow(0.4,2) / (log(Tz/z0)*log(Vz/z0));     // Bulk-transfer coefficient
-	C = An * dAir * V;                        // shf & lhf common coefficient
+	An =  pow(0.4,2); // Bulk-transfer coefficient
+	C = An*V;  // shf & lhf common coefficient
+	An_den_T = (log(Tz/zT)*log(Vz/z0)); 
+	An_den_Q = (log(Tz/zQ)*log(Vz/z0)); 
 
 	// THERMAL CONDUCTIVITY (Sturm, 1997: J. Glaciology)
@@ -807,9 +834,14 @@
 	K= xNewZeroInit<IssmDouble>(m);
 
-	// for snow and firn (density < 910 kg m-3) (Sturn et al, 1997)
-	for(int i=0;i<m;i++) if(d[i]<dIce-Dtol) K[i] = 0.138 - 1.01E-3 * d[i] + 3.233E-6 * (pow(d[i],2));
+	// for snow and firn (density < 910 kg m-3) (Sturm et al, 1997) or (Calonne et al., 2011)
+	if (tcIdx == 2){
+		for(int i=0;i<m;i++) if(d[i]<dIce-Dtol) K[i] = 0.024 - 1.23e-4 * d[i] + 2.5e-6 * (pow(d[i],2));
+	}
+	else{ //default (Sturm et al, 1997)
+		for(int i=0;i<m;i++) if(d[i]<dIce-Dtol) K[i] = 0.138 - 1.01e-3 * d[i] + 3.233e-6 * (pow(d[i],2));
+	}
 
 	// for ice (density >= 910 kg m-3)
-	for(int i=0;i<m;i++) if(d[i]>=dIce-Dtol) K[i] = 9.828 * exp(-5.7E-3*T[i]);
+	for(int i=0;i<m;i++) if(d[i]>=dIce-Dtol) K[i] = 9.828 * exp(-5.7e-3*T[i]);
 
 	// THERMAL DIFFUSION COEFFICIENTS
@@ -824,6 +856,6 @@
 	// where neighbor coefficients Au, Ap, & Ad are
 
-	//                   Au = [dz_u/2KP + dz_p/2KE]^-1
-	//                   Ad = [dz_d/2KP + dz_d/2KD]^-1 
+	//                   Au = [dz_u/2KU + dz/2KP]^-1
+	//                   Ad = [dz_d/2KD + dz/2KP]^-1
 	//                   Ap = d*CI*dz/Dt 
 
@@ -836,5 +868,5 @@
 	KP = xNew<IssmDouble>(m);
 
-	KU[0] = Delflag;
+	KU[0] = Delflag; //Thermal conductivity of air = 0.025 W/m/K
 	KD[m-1] = Delflag;
 	for(int i=1;i<m;i++) KU[i]= K[i-1];
@@ -854,5 +886,5 @@
 	// NS: 2.16.18 divided dt by scaling factor, default set to 1/11 for stability
 	dt=1e12; 
-	for(int i=0;i<m;i++)dt = min(dt,CI * pow(dz[i],2) * d[i]  / (3 * K[i]) * thermo_scaling);
+	for(int i=0;i<m;i++) dt = min(dt,CI * pow(dz[i],2) * d[i]  / (3 * K[i]) * thermo_scaling);
 
 	// smallest possible even integer of 60 min where diffusion number > 1/2
@@ -875,13 +907,13 @@
 	Ap = xNew<IssmDouble>(m);
 	for(int i=0;i<m;i++){
-		Au[i] = pow((dzU[i]/2.0/KP[i] + dz[i]/2.0/KU[i]),-1.0);
-		Ad[i] = pow((dzD[i]/2.0/KP[i] + dz[i]/2.0/KD[i]),-1.0);
+		Au[i] = pow((dzU[i]/2.0/KU[i] + dz[i]/2.0/KP[i]),-1.0);
+		Ad[i] = pow((dzD[i]/2.0/KD[i] + dz[i]/2.0/KP[i]),-1.0);
 		Ap[i] = (d[i]*dz[i]*CI)/dt;
 	}
 
 	// create "neighbor" coefficient matrix
-	Nu = xNew<IssmDouble>(m);
-	Nd = xNew<IssmDouble>(m);
-	Np = xNew<IssmDouble>(m);
+	Nu = xNewZeroInit<IssmDouble>(m);
+	Nd = xNewZeroInit<IssmDouble>(m);
+	Np = xNewZeroInit<IssmDouble>(m);
 	for(int i=0;i<m;i++){
 		Nu[i] = Au[i] / Ap[i];
@@ -934,10 +966,5 @@
 
 		// calculate temperature of snow surface (Ts)
-		// when incoming SW radition is allowed to penetrate the surface,
-		// the modeled energy balance becomes very sensitive to how Ts is
-		// calculated.  The estimated enegy balance & melt are significanly
-		// less when Ts is taken as the mean of the x top grid cells.
-		if(m>1) Ts = (T[0] + T[1])/2.0;
-		else Ts = T[0];
+		Ts = T[0];
 		Ts = min(CtoK,Ts);    // don't allow Ts to exceed 273.15 K (0 degC)
 
@@ -950,55 +977,179 @@
 
 		// calculate the Bulk Richardson Number (Ri)
-		Ri = (2.0*9.81* (Vz - z0) * (Ta - Ts)) / ((Ta + Ts)* pow(V,2.0));
-		//Ri = (2.0*9.81*(Ta - Ts)) / ((Tz - z0)*(Ta + Ts)* pow(V/(Vz - z0),2.0));
+		Ri = pow(100000/pAir,0.286)*(2.0*9.81*(Ta - Ts)) / (Tz*(Ta + Ts)* pow(V/(Vz),2.0));
+
+		IssmDouble PhiM;
+		IssmDouble PhiH;
 
 		// calculate Monin-Obukhov stability factors 'coefM' and 'coefH'
-
-		// do not allow Ri to exceed 0.16
-		// Ri = min(Ri, 0.19);
-		Ri = min(Ri, 0.16); //Ohmura, 1982
-
-		// calculate momentum 'coefM' stability factor
-		if (Ri > 0.0+Ttol){
-			// if stable
-			coefM = 1.0/(1.0-5.2*Ri);
-		}
-		else {
-			coefM =pow (1.0-18*Ri,-0.25);
-		}
-
-		// calculate heat/wind 'coef_H' stability factor
-		if (Ri <= -0.03+Ttol) coefH = coefM/1.3;
-		else coefH = coefM;
-
-		//// Sensible Heat
-		// calculate the sensible heat flux [W m-2](Patterson, 1998)
-		shf = C * CA * (Ta - Ts);
-
-		// adjust using Monin-Obukhov stability theory
-		shf = shf / (coefM * coefH);
-
-		//// Latent Heat
-		// determine if snow pack is melting & calcualte surface vapour pressure over ice or liquid water
-		if (Ts >= CtoK-Ttol){
-			L = LV; //for liquid water at 273.15 k to vapor
-
-			//for liquid surface (assume liquid on surface when Ts == 0 deg C)
-			// Wright (1997), US Meteorological Handbook from Murphy and Koop, 2005 Appendix A
-			eS = 611.21 * exp(17.502 * (Ts - CtoK) / (240.97 + Ts - CtoK));
-		}
-		else{
-			L = LS; // latent heat of sublimation 
-
-			// for an ice surface Murphy and Koop, 2005 [Equation 7]
-			eS = exp(9.550426 - 5723.265/Ts + 3.53068 * log(Ts) - 0.00728332 * Ts);
-		}
-
-		// Latent heat flux [W m-2]
-		lhf = C * L * (eAir - eS) * 0.622 / pAir;
-
-		// adjust using Monin-Obukhov stability theory (if lhf '+' then there is energy and mass gained at the surface, 
-		// if '-' then there is mass and energy loss at the surface.
-		lhf = lhf / (coefM * coefH);
+		if (false){
+			// do not allow Ri to exceed 0.16
+			Ri = min(Ri, 0.16); //Ohmura, 1982
+
+			// calculate momentum 'coefM' stability factor
+			if (Ri > 0.0+Ttol){
+				// if stable
+				coefM = 1.0/(1.0-5.2*Ri);
+			}
+			else {
+				coefM =pow (1.0-18*Ri,-0.25);
+			}
+
+			// calculate heat/wind 'coef_H' stability factor
+			if (Ri <= -0.03+Ttol) coefH = coefM/1.3;
+			else coefH = coefM;
+
+         coefHT = coefH*An_den_T;
+         coefHQ = coefH*An_den_Q;
+
+		}
+		else if(false){
+
+			// do not allow Ri to exceed 0.19
+			Ri = min(Ri, 0.19); //Ohmura, 1982
+
+			// calculate momentum 'coefM' stability factor
+			if (Ri > 0.0+Ttol){
+				// if stable
+				//coefM = pow(1.0-5.0*Ri,2.0); //Fitzpatrick et al., 2017, from Brock et al., 2010
+				coefM=1+5.3*min((Ri/(1-5*Ri)),0.5);
+				coefH=1+8*min((Ri/(1-5*Ri)),0.5);
+			}
+			else {
+				//coefM =pow(1.0-16.0*max(Ri,-1.0),0.75); //Fitzpatrick et al., 2017, from Brock et al., 2010
+				coefM=pow(1-19*max(Ri/1.5,-2.0),-0.25);
+				coefH=0.95*pow(1-11.6*max(Ri/1.5,-2.0),-0.5);
+			}
+
+			coefHT = coefH*An_den_T;
+			coefHQ = coefH*An_den_Q;
+
+		}
+      else if (false){
+         // Greuell and Konzelman, 1994
+         // calculate momentum 'coefM' stability factor
+
+         if (Ri > 0.0+Ttol){
+            // if stable
+            coefM=1+15*Ri*pow(1+Ri,1/2);
+            coefH=1;
+         }
+         else {
+            coefM=pow(1-15*Ri/(1+75*pow(0.4/log(Tz/zT),2)*pow(Tz/zT*fabs(Ri),1/2)),-1);
+            coefH=1;
+         }
+
+         coefHT = coefH*An_den_T;
+         coefHQ = coefH*An_den_Q;
+
+      }
+      else {
+         IssmDouble a1=1.0;
+         IssmDouble b1=2/3;
+         IssmDouble c1=5.0;
+         IssmDouble d1=0.35;
+         IssmDouble PhiMz;
+         IssmDouble PhiHz;
+         IssmDouble PhiMz0=0.0;
+         IssmDouble PhiHzT=0.0;
+         IssmDouble PhiHzQ=0.0;
+         IssmDouble zL;
+         IssmDouble zLT;
+         IssmDouble zLM;
+
+         if (Ri > 0.0+Ttol){
+            // if stable
+
+            if(Ri < 0.2-Ttol){
+               zL = Ri/(1-5*Ri);
+            }
+            else{
+               zL=Ri;
+            }
+            //zL = min(zL, 0.5); //Sjoblom, 2014
+            zLM=max(zL/Vz*z0,1e-3);
+            zLT=max(zL/Tz*zT,1e-3);
+
+            //Ding et al. 2020, from Beljaars and Holtslag (1991)
+            PhiMz=-1*(a1*zL + b1*(zL-c1/d1)*exp(-1*d1*zL) + b1*c1/d1);
+            PhiHz=-1*(pow(1+2*a1*zL/3,1.5) + b1*(zL-c1/d1)*exp(-1*d1*zL) + b1*c1/d1 - 1);
+            PhiMz0=-1*(a1*zLM + b1*(zLM-c1/d1)*exp(-1*d1*zLM) + b1*c1/d1);
+            PhiHzT=-1*(pow(1+2*a1*zLT/3,1.5) + b1*(zLT-c1/d1)*exp(-1*d1*zLT) + b1*c1/d1 - 1);
+
+            PhiHzQ=PhiHzT;
+         }
+         else {
+            IssmDouble xm;
+            IssmDouble xh;
+            IssmDouble xmT;
+            IssmDouble xmM;
+
+            zL = Ri/1.5; //max(Ri, -0.5+Ttol)/1.5; //Hogstrom (1996)
+            //zL = max(zL, -2.0); //Sjoblom, 2014
+            zLM=min(zL/Vz*z0,-1e-3);
+            zLT=min(zL/Tz*zT,-1e-3);
+
+            if (true){ //Sjoblom, 2014
+               xm=pow(1.0-19*zL,-0.25);
+               PhiMz=2*log((1+xm)/2.0) + log((1+pow(xm,2))/2.0) - 2*atan(xm) + Pi/2;
+
+               xh=0.95*pow(1.0-11.6*zL,-0.5);
+               PhiHz=2*log((1+pow(xh,2))/2.0);
+            }
+            else{ //Ding et al., 2020
+               xm=pow(1.0-16*zL,0.25);
+               xmM=pow(1.0-16*zLM,0.25);
+               xmT=pow(1.0-16*zLT,0.25);
+               PhiMz=2*log((1+xm)/2.0) + log((1+pow(xm,2))/2.0) - 2*atan(xm) + Pi/2;
+               PhiMz0=2*log((1+xmM)/2.0) + log((1+pow(xmM,2))/2.0) - 2*atan(xmM) + Pi/2;
+
+               PhiHz=2*log((1+pow(xm,2))/2.0);
+               PhiHzT=2*log((1+pow(xmT,2))/2.0);
+
+               PhiHzQ=PhiHzT;
+            }
+         }
+
+         PhiM=PhiMz;
+         PhiH=PhiHz;
+         coefM = log(Vz/z0) - PhiMz + PhiMz0; //Ding et al., 2019
+         coefHT = log(Tz/zT) - PhiHz + PhiHzT; //Sjoblom, 2014, after Foken 2008
+         coefHQ = log(Tz/zQ) - PhiHz + PhiHzQ; //Sjoblom, 2014, after Foken 2008
+
+      }
+
+      //// Sensible Heat
+      // calculate the sensible heat flux [W m-2](Patterson, 1998)
+      shf = dAir * C * CA * (Ta - Ts) * pow(100000/pAir,0.286);
+
+      // adjust using Monin-Obukhov stability theory
+      shf = shf/(coefM*coefHT);
+
+      //// Latent Heat
+      // determine if snow pack is melting & calcualte surface vapour pressure over ice or liquid water
+      if (Ts >= CtoK-Ttol){
+         L = LV; //for liquid water at 273.15 k to vapor
+
+         //for liquid surface (assume liquid on surface when Ts == 0 deg C)
+         // Wright (1997), US Meteorological Handbook from Murphy and Koop, 2005 Appendix A
+         //eS = 611.21 * exp(17.502 * (Ts - CtoK) / (240.97 + Ts - CtoK));
+         // Murray 1967, https://cran.r-project.org/web/packages/humidity/vignettes/humidity-measures.html
+         eS = 610.78 * exp(17.2693882 * (Ts - CtoK - 0.01) / (Ts - 35.86));
+      }
+      else{
+         L = LS; // latent heat of sublimation
+
+         // for an ice surface Murphy and Koop, 2005 [Equation 7]
+         //eS = exp(9.550426 - 5723.265/Ts + 3.53068 * log(Ts) - 0.00728332 * Ts);
+         // for an ice surface Ding et al., 2019 after Bolton, 1980
+         eS = 610.78 * exp(21.8745584 * (Ts - CtoK - 0.01) / (Ts - 7.66));
+      }
+
+      // Latent heat flux [W m-2]
+      lhf = C * L * (eAir - eS) / (461.9*(Ta+Ts)/2);
+
+      // adjust using Monin-Obukhov stability theory (if lhf '+' then there is energy and mass gained at the surface,
+      // if '-' then there is mass and energy loss at the surface.
+      lhf = lhf/(coefM*coefHQ);
 
 		//mass loss (-)/acreation(+) due to evaporation/condensation [kg]
@@ -1025,9 +1176,13 @@
 
 		//SW penetrates surface
-		if(!isconstrainsurfaceT) for(int j=0;j<m;j++) T[j] = T[j] + dT_sw[j];
-		if(!isconstrainsurfaceT) T[0] = T[0] + dT_dlw + dT_ulw + dT_turb;
+		if(!isconstrainsurfaceT){
+			for(int j=0;j<m;j++) T[j] = T[j] + dT_sw[j];
+			T[0] = T[0] + dT_dlw + dT_ulw + dT_turb;
+		}
 
 		// temperature diffusion
 		for(int j=0;j<m;j++) T0[1+j]=T[j];
+		T0[0]=Ta;
+		T0[m+1]=T[m-1];
 		for(int j=0;j<m;j++) Tu[j] = T0[j];
 		for(int j=0;j<m;j++) Td[j] = T0[2+j];
@@ -1036,4 +1191,6 @@
 		// calculate cumulative evaporation (+)/condensation(-)
 		if(!isconstrainsurfaceT) EC = EC + (EC_day/dts)*dt;
+		lhf_cum=lhf_cum+lhf*dt/dt0;
+		shf_cum=shf_cum+shf*dt/dt0;
 
 		/* CHECK FOR ENERGY (E) CONSERVATION [UNITS: J]
@@ -1073,4 +1230,6 @@
 	/*Assign output pointers:*/
 	*pEC=EC;
+	*plhf=lhf_cum;
+	*pshf=shf_cum;
 	*pT=T;
 	*pulwrf=ulwrf;
@@ -1111,5 +1270,5 @@
 
 	// SHORTWAVE FUNCTION
-	if (swIdx == 0) {// all sw radation is absorbed in by the top grid cell
+	if (swIdx == 0 | (dIce - d[0])<Dtol) {// all sw radation is absorbed in by the top grid cell
 
 		// calculate surface shortwave radiation fluxes [W m-2]
@@ -1154,5 +1313,5 @@
 			// spectral albedos:
 			// 0.3 - 0.8um
-			IssmDouble a0 = min(0.98, 1.0 - 1.58 *pow(gsz[0],0.5));
+			IssmDouble a0 = min(0.98, 0.95 - 1.58 *pow(gsz[0],0.5));
 			// 0.8 - 1.5um
 			IssmDouble a1 = max(0.0, 0.95 - 15.4 *pow(gsz[0],0.5));
@@ -1308,7 +1467,7 @@
 	// specify constants
 	IssmDouble dSnow = 150;    // density of snow [kg m-3]
-	const IssmDouble reNew = 0.05;    // new snow grain size [mm]
-	const IssmDouble gdnNew = 1.0;     // new snow dendricity 
-	const IssmDouble gspNew = 0.5;   // new snow sphericity 
+	IssmDouble reNew = 0.05;    // new snow grain size [mm]
+	IssmDouble gdnNew = 1.0;     // new snow dendricity 
+	IssmDouble gspNew = 0.5;   // new snow sphericity 
 
 	/*intermediary: */
@@ -1359,4 +1518,8 @@
 		case 2: // Density of Greenland snow, Fausto et al., 2018
 			dSnow = 315;
+			//From Vionnet et al., 2012 (Crocus)
+			gdnNew = min(max(1.29 - 0.17*V,0.20),1.0);
+			gspNew = min(max(0.08*V + 0.38,0.5),0.9);
+			reNew=max(1e-1*(gdnNew/.99+(1-1*gdnNew/.99)*(gspNew/.99*3+(1-gspNew/.99)*4))/2,Gdntol);
 			break;
 
@@ -1386,9 +1549,4 @@
 			IssmDouble sfall = gspNew;
 			IssmDouble refall = reNew;
-
-			//From Vionnet et al., 2012 (Crocus)
-			dfall = min(max(1.29 - 0.17*V,0.20),1.0);
-			sfall = min(max(0.08*V + 0.38,0.5),0.9);
-			refall = max((0.1 + (1.0-dfall)*0.25 + (0.5-sfall)*0.1)/2.0,Gdntol);
 
 			// if snow depth is greater than specified min dz, new cell created
@@ -1419,7 +1577,7 @@
 				// adjust a, re, gdn & gsp
 				if(aIdx>0)a[0] = (aSnow * P + a[0] * mInit[0])/mass;
-				gdn[0] = (dfall * P + gdn[0] * mInit[0])/mass;
-				gsp[0] = (sfall * P + gsp[0] * mInit[0])/mass;
-				re[0] = max((0.1 + (1.0-gdn[0])*0.25 + (0.5-gsp[0])*0.1)/2.0,Gdntol);
+				gdn[0] = dfall; 
+				gsp[0] = sfall; 
+				re[0] = max(1e-1*(gdn[0]/.99+(1-1*gdn[0]/.99)*(gsp[0]/.99*3+(1-gsp[0]/.99)*4))/2,Gdntol);
 			}
 		}
@@ -1512,27 +1670,4 @@
 	IssmDouble X=0.0;
 	IssmDouble Wi=0.0;
-
-	IssmDouble Ztot=0.0;
-	IssmDouble T_bot=0.0;
-	IssmDouble m_bot=0.0;
-	IssmDouble dz_bot=0.0;
-	IssmDouble d_bot=0.0;
-	IssmDouble W_bot=0.0;
-	IssmDouble a_bot=0.0;
-	IssmDouble adiff_bot=0.0;
-	IssmDouble re_bot=0.0;
-	IssmDouble gdn_bot=0.0;
-	IssmDouble gsp_bot=0.0;
-	IssmDouble EI_bot=0.0;
-	IssmDouble EW_bot=0.0;
-	bool        top=false;
-
-	IssmDouble* Zcum=NULL;
-	IssmDouble* dzMin2=NULL;
-	IssmDouble* dzMax2=NULL;
-	IssmDouble zY2=zY;
-	bool lastCellFlag = false;
-	int X1=0;
-	int X2=0;
 
 	int        D_size = 0;
@@ -1828,4 +1963,109 @@
 	xDelete<IssmDouble>(F);
 
+	//Manage the layering to match the user defined requirements
+	managelayers(&mAdd, &dz_add, &addE, &m, &EI, &EW, &T, &d, &dz, &W, &a, &adiff, &re, &gdn, &gsp, &n, dzMin, zMax, zMin, zTop, zY);
+
+	//// CHECK FOR MASS AND ENERGY CONSERVATION
+
+	// calculate final mass [kg] and energy [J]
+	sumER = Rsum * (LF + CtoK * CI);
+	for(int i=0;i<n;i++)EI[i] = m[i] * T[i] * CI;
+	for(int i=0;i<n;i++)EW[i] = W[i] * (LF + CtoK * CI);
+
+	mSum1 = cellsum(W,n) + cellsum(m,n) + Rsum;
+	sumE1 = cellsum(EI,n) + cellsum(EW,n);
+
+	/*checks: */
+	for(int i=0;i<n;i++) if (W[i]<0.0-Wtol) _error_("negative pore water generated in melt equations\n");
+
+	/*only in forward mode! avoid round in AD mode as it is not differentiable: */
+	#ifndef _HAVE_AD_
+	dm = round((mSum0 - mSum1 + mAdd)*100.0)/100.0;
+	dE = round(sumE0 - sumE1 - sumER +  addE - surplusE);
+	if (dm !=0  || dE !=0) _error_("mass or energy are not conserved in melt equations\n"
+			<< "dm: " << dm << " dE: " << dE << "\n");
+	#endif
+
+	/*Free resources:*/
+	if(m)xDelete<IssmDouble>(m);
+	if(EI)xDelete<IssmDouble>(EI);
+	if(EW)xDelete<IssmDouble>(EW);
+	if(maxF)xDelete<IssmDouble>(maxF);
+	if(dW)xDelete<IssmDouble>(dW);
+	if(exsW)xDelete<IssmDouble>(exsW);
+	if(exsT)xDelete<IssmDouble>(exsT);
+	if(surpT)xDelete<IssmDouble>(surpT);
+	if(surpE)xDelete<IssmDouble>(surpE);
+	if(flxDn)xDelete<IssmDouble>(flxDn);
+	if(D)xDelete<int>(D);
+	if(M)xDelete<IssmDouble>(M);
+
+	/*Assign output pointers:*/
+	*pMs=Msurf;
+	*pM=sumM;
+	*pR=Rsum;
+	*pF=Fsum;
+	*pmAdd=mAdd;
+	*pdz_add=dz_add;
+
+	*pT=T;
+	*pd=d;
+	*pdz=dz;
+	*pW=W;
+	*pa=a;
+	*padiff=adiff;
+	*pre=re;
+	*pgdn=gdn;
+	*pgsp=gsp;
+	*pn=n;
+
+} /*}}}*/ 
+void managelayers(IssmDouble* pmAdd, IssmDouble* pdz_add, IssmDouble* paddE, IssmDouble** pm, IssmDouble** pEI, IssmDouble** pEW, IssmDouble** pT, IssmDouble** pd, IssmDouble** pdz, IssmDouble** pW, IssmDouble** pa, IssmDouble** padiff, IssmDouble** pre, IssmDouble** pgdn, IssmDouble** pgsp, int* pn, IssmDouble dzMin, IssmDouble zMax, IssmDouble zMin, IssmDouble zTop, IssmDouble zY){ /*{{{*/
+
+	/*intermediary:*/
+	IssmDouble* Zcum=NULL;
+	IssmDouble* dzMin2=NULL;
+	IssmDouble* dzMax2=NULL;
+	int*        D=NULL;
+
+	IssmDouble zY2=zY;
+	IssmDouble X=0.0;
+	int X1=0;
+	int X2=0;
+	int D_size = 0;
+
+	IssmDouble Ztot=0.0;
+	IssmDouble T_bot=0.0;
+	IssmDouble m_bot=0.0;
+	IssmDouble dz_bot=0.0;
+	IssmDouble d_bot=0.0;
+	IssmDouble W_bot=0.0;
+	IssmDouble a_bot=0.0;
+	IssmDouble adiff_bot=0.0;
+	IssmDouble re_bot=0.0;
+	IssmDouble gdn_bot=0.0;
+	IssmDouble gsp_bot=0.0;
+	IssmDouble EI_bot=0.0;
+	IssmDouble EW_bot=0.0;
+	bool       top=false;
+
+	/*outputs:*/
+	IssmDouble  mAdd = 0.0;
+	IssmDouble  addE = 0.0;
+	IssmDouble  dz_add = 0.0;
+	IssmDouble* T=*pT;
+	IssmDouble* d=*pd;
+	IssmDouble* dz=*pdz;
+	IssmDouble* W=*pW;
+	IssmDouble* a=*pa;
+	IssmDouble* adiff=*padiff;
+	IssmDouble* re=*pre;
+	IssmDouble* gdn=*pgdn;
+	IssmDouble* gsp=*pgsp;
+	IssmDouble* m=*pm;
+	IssmDouble* EI=*pEI;
+	IssmDouble* EW=*pEW;
+	int         n=*pn;
+
 	//Merging of cells as they are burried under snow.
 	Zcum=xNew<IssmDouble>(n);
@@ -1875,7 +2115,8 @@
 			a[X1] = (a[X2]*m[X2] + a[X1]*m[X1]) / m_new;
 			adiff[X1] = (adiff[X2]*m[X2] + adiff[X1]*m[X1]) / m_new;
-			re[X1] = (re[X2]*m[X2] + re[X1]*m[X1]) / m_new;
-			gdn[X1] = (gdn[X2]*m[X2] + gdn[X1]*m[X1]) / m_new;
-			gsp[X1] = (gsp[X2]*m[X2] + gsp[X1]*m[X1]) / m_new;
+         //use grain properties from lower cell
+			re[X1] = re[X2]; 
+			gdn[X1] = gdn[X2]; 
+			gsp[X1] = gsp[X2]; 
 
 			// merge with underlying grid cell and delete old cell
@@ -2019,50 +2260,11 @@
 	}
 
-	//// CHECK FOR MASS AND ENERGY CONSERVATION
-
-	// calculate final mass [kg] and energy [J]
-	sumER = Rsum * (LF + CtoK * CI);
-	for(int i=0;i<n;i++)EI[i] = m[i] * T[i] * CI;
-	for(int i=0;i<n;i++)EW[i] = W[i] * (LF + CtoK * CI);
-
-	mSum1 = cellsum(W,n) + cellsum(m,n) + Rsum;
-	sumE1 = cellsum(EI,n) + cellsum(EW,n);
-
-	/*checks: */
-	for(int i=0;i<n;i++) if (W[i]<0.0-Wtol) _error_("negative pore water generated in melt equations\n");
-
-	/*only in forward mode! avoid round in AD mode as it is not differentiable: */
-	#ifndef _HAVE_AD_
-	dm = round((mSum0 - mSum1 + mAdd)*100.0)/100.0;
-	dE = round(sumE0 - sumE1 - sumER +  addE - surplusE);
-	if (dm !=0  || dE !=0) _error_("mass or energy are not conserved in melt equations\n"
-			<< "dm: " << dm << " dE: " << dE << "\n");
-	#endif
-
 	/*Free resources:*/
-	if(m)xDelete<IssmDouble>(m);
-	if(EI)xDelete<IssmDouble>(EI);
-	if(EW)xDelete<IssmDouble>(EW);
-	if(maxF)xDelete<IssmDouble>(maxF);
-	if(dW)xDelete<IssmDouble>(dW);
-	if(exsW)xDelete<IssmDouble>(exsW);
-	if(exsT)xDelete<IssmDouble>(exsT);
-	if(surpT)xDelete<IssmDouble>(surpT);
-	if(surpE)xDelete<IssmDouble>(surpE);
-	if(flxDn)xDelete<IssmDouble>(flxDn);
-	if(D)xDelete<int>(D);
-	if(M)xDelete<IssmDouble>(M);
  	xDelete<IssmDouble>(Zcum);
 	xDelete<IssmDouble>(dzMin2);
 	xDelete<IssmDouble>(dzMax2);
+	if(D)xDelete<int>(D);
 
 	/*Assign output pointers:*/
-	*pMs=Msurf;
-	*pM=sumM;
-	*pR=Rsum;
-	*pF=Fsum;
-	*pmAdd=mAdd;
-	*pdz_add=dz_add;
-
 	*pT=T;
 	*pd=d;
@@ -2075,4 +2277,11 @@
 	*pgsp=gsp;
 	*pn=n;
+	*pm=m;
+	*pEI=EI;
+	*pEW=EW;
+
+	*pmAdd=mAdd;
+	*paddE=addE;
+	*pdz_add=dz_add;
 
 } /*}}}*/ 
@@ -2128,7 +2337,9 @@
 	IssmDouble c0=0.0;
 	IssmDouble c1=0.0;
+   IssmDouble c2=0.0;
 	IssmDouble H=0.0;
 	IssmDouble M0=0.0;
 	IssmDouble M1=0.0;
+   IssmDouble M2=0.0;
 	IssmDouble c0arth=0.0;
 	IssmDouble c1arth=0.0;
@@ -2206,10 +2417,7 @@
 				if (aIdx==1 && swIdx==0){
 					if (fabs(adThresh - 820) < Dtol){
-						// ERA5 new aIdx=1, swIdx=0, MODIS 820
-						//M0 = max(1.8230 - (0.1645 * log(C)),0.25);
-						//M1 = max(2.5134 - (0.3244 * log(C)),0.25);
-						// ERA5 new aIdx=1, swIdx=0, MODIS 820, p90 new (ERA5, 40 and e97)
-						M0 = max(1.3045 - (0.0988 * log(C)),0.25);
-						M1 = max(1.3694 - (0.1354 * log(C)),0.25);
+                  // ERA5 v4
+                  M0 = max(1.5131 - (0.1317 * log(C)),0.25);
+                  M1 = max(1.8819 - (0.2158 * log(C)),0.25);
 					}
 					else{
@@ -2234,9 +2442,10 @@
 				//M0 = max(1.435 - (0.151 * log(C)),0.25);
 				//M1 = max(2.366 - (0.293 * log(C)),0.25);
-				//RACMO
-				M0 = max(1.6599 - (0.1724 * log(C)),0.25);
-				M1 = max(2.0102 - (0.2458 * log(C)),0.25);
+            //RACMO
+            M0 = max(1.6383 - (0.1691 * log(C)),0.25);
+            M1 = max(1.9991 - (0.2414 * log(C)),0.25);
 				c0 = M0*c0arth;
 				c1 = M1*c1arth;
+				c2 = M2*c1arth;
 				break;
 
@@ -2253,10 +2462,7 @@
 				if (aIdx==1 && swIdx==0){
 					if (fabs(adThresh - 820) < Dtol){
-						// ERA5 new aIdx=1, swIdx=0, MODIS 820
-						//M0 = max(1.4174 - (0.1037 * log(C)),0.25);
-						//M1 = max(2.2010 - (0.2460 * log(C)),0.25);
-						// ERA5 new aIdx=1, swIdx=0, MODIS 820, p90 new (ERA5 lwt, 40 and e97)
-						M0 = max(1.2138 - (0.1057 * log(C)),0.25);
-						M1 = max(1.4946 - (0.1607 * log(C)),0.25);
+						// ERA5 v4
+						M0 = max(1.3566 - (0.1350 * log(C)),0.25);
+						M1 = max(1.8705 - (0.2290 * log(C)),0.25);
 					}
 					else{
@@ -2281,16 +2487,16 @@
 				//M1 = max(1.734 - (0.2039 * log(C)),0.25);
 				// RACMO
-				M0 = max(1.6201 - (0.1450 * log(C)),0.25);
-				M1 = max(2.5577 - (0.2899 * log(C)),0.25);
-				c0 = M0*c0arth;
-				c1 = M1*c1arth;
+            M0 = max(1.2691 - (0.1184 * log(C)),0.25);
+            M1 = max(1.9983 - (0.2511 * log(C)),0.25);
+            c0 = M0*c0arth;
+            c1 = M1*c1arth;
+            c2 = M2*c1arth;
 				break;
 		}
 
-		// new snow density
-		if(d[i] <= 550.0+Dtol) d[i] = d[i] + (c0 * (dIce - d[i]) / 365.0 * dt);
-		else            d[i] = d[i] + (c1 * (dIce - d[i]) / 365.0 * dt);
-
-		//disp((num2str(nanmean(c0 .* (dIce - d(idx)) / 365 * dt))))
+      // new snow density
+      if(d[i] <= 550.0+Dtol) d[i] = d[i] + (c0 * (dIce - d[i]) / 365.0 * dt);
+      else if(d[i] <= 830.0+Dtol | fabs(c2)<Dtol) d[i] = d[i] + (c1 * (dIce - d[i]) / 365.0 * dt);
+      else d[i] = d[i] + (c2 * (dIce - d[i]) / 365.0 * dt);
 
 		// do not allow densities to exceed the density of ice
